//+------------------------------------------------------------------+
//|                                                   Proboi+RSI.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//---------------------------------------------------------------------------------1---
extern double StopLoss          = 20;          //SL  . 
extern double TakeProfit        = 30;          //TP  . 
extern double Lots              = 1;           // . - 
extern double Prots             = 1;           //   

//-------------------------------------------------------------------------------------
extern double Kolihestvo_Barov  = 5;           //   
extern int    RSIPeriod         =14;           //   RSI

//------------------------------------------------------------------------------------
bool Work       = true;                        //   
bool Flag_Rsi_B = true;                        //    
bool Flag_Rsi_S = true;                        //    

//------------------------------------------------------------------------------------
string Symb;                                   //                                     

//---------------------------------------------------------------------------------2---
int start()
   {
    int Ticket;      // 
    
//-------------------------------------------------------------------------------------   
    double
    SL,        //StopLoss
    TP,        //TakeProfite
    Min_Lot,   // - 
    Free,      //  
    One_Lot,   //  
    Steep,     //   
    Lts;       //   .    
     
//-------------------------------------------------------------------------------------    
    bool
    Opn_B   = false,   //   Bay
    Opn_S   = false;   //   Sell
//---------------------------------------------------------------------------------3---     
   //     
    
    if(Bars < Kolihestvo_Barov)                                   // .   ..        
      {                                                                    
       Alert("   .   .");  //..  
       return;                                                    //..   
      }
   if(Work==false)                                                //                       
      {
       Alert(" .   .");         // 
       return;                                                    //  - 
      }
//-----------------------------------------------------------------------------------4--- 
   // 
   Symb=  Symbol();                             //                                   
   for(int i=1; i<=OrdersTotal(); i++)          //   
      {
       if(OrderSelect(i-1,SELECT_BY_POS)==true) //    
         {
          if(OrderSymbol() == Symb)    //  
            {
             if(OrderMagicNumber()==777)
                return;
            }    
         }   
      }      
//-----------------------------------------------------------------------------------5---
   // 
   
   //  .  .   n    
   double Line_1= Low[iLowest(NULL,0,MODE_LOW,Kolihestvo_Barov,1)];     // 
   double Line_2= High[iHighest(NULL,0,MODE_HIGH,Kolihestvo_Barov,1)];  // 
   
   // RSI 
   double Rsi= iRSI(NULL,0,RSIPeriod,0,0);
   
   //  BUY 
   if(Flag_Rsi_B==true)
      { 
       if(Rsi < 30)
         {
          Alert(" - -  RSI min");     
          Flag_Rsi_B=false;
      }  } 
   if(Bid > Line_2 && Flag_Rsi_B==false)  
      {
       Alert(" - -    ");     
       Opn_B= true;  
       Flag_Rsi_B=true;
      }
        
   //  SELL   
   if(Flag_Rsi_S==true)
      {
       if(Rsi > 70)
         {   
          Flag_Rsi_S=false;
          Alert(" - -  RSI ");
         }  
      }
      
   if(Flag_Rsi_S==false && Bid < Line_1)
      {
       Alert(" - -    "); 
       Opn_S= true;  
       Flag_Rsi_S= true;
      }  
               
   //----------------------------------------------------------------------------------6---             
   // 
   RefreshRates();                                       // 
   Min_Lot= MarketInfo(Symbol(),MODE_MINLOT);            // - 
   Free=    AccountFreeMargin();                         // 
   One_Lot= MarketInfo(Symbol(),MODE_MARGINREQUIRED);    //  
   Steep=   MarketInfo(Symbol(),MODE_LOTSTEP);           //  
   
   if(Lots >= 0.01)                                      //  ..   
      Lts= Lots;                                         //..    
   else
      Lts= MathFloor(Free*Prots/One_Lot/Steep)*Steep;    //    
      
   if(Lts < Min_Lot)                                     //    ..  
      Lts= Min_Lot;                                      //..  .   
      
   if(Lts*One_Lot > Free)                                // . .   . ..  
      {
       Alert("    ",Lts," ");       //..  ..
       return;                                           //..        
      }      
      
//----------------------------------------------------------------------------------7---     
   //  
   while(true) 
      {
       if(Opn_B==true)                          //  Buy                     
         {                                      
          RefreshRates();                       // 
          SL= Bid - New_Stop(StopLoss)*Point;   // SL   
          TP= Bid + New_Stop(TakeProfit)*Point; // TP 
          Alert("  Bay,  ..");
          Ticket= OrderSend(Symbol(),OP_BUY,Lts,Ask,5,SL,TP,"",777);  // Buy
          if (Ticket > 0)                                      //
            {
             Alert("  Bay ",Ticket);
             return;
            }
            
            if (Fun_Error(GetLastError())==1)      //  
            continue;                              //  
          return;                                  //   start()
            
          }  
      if(Opn_S==true)                             //  Sell
         {                                        
          RefreshRates();                         // 
          SL= Ask + New_Stop(StopLoss)*Point;     // SL   
          TP= Ask - New_Stop(TakeProfit)*Point;   // TP 
          Alert("  Sell,  ..");
          Ticket= OrderSend(Symbol(),OP_SELL,Lts,Bid,5,SL,TP,"",777);  // Buy
          if (Ticket > 0)                                              //
            {
             Alert("  Sell ",Ticket);
             return;
            }
            if (Fun_Error(GetLastError())==1)      //  
            continue;                              //  
          return;                                  //   start()
            
          } 
        break;                                    //  while
      }             
     return;
     }

//----------------------------------------------------------------------------------8---   
  // 
int Fun_Error(int Error)                        // -  
  {
   switch(Error)
     {                                          //              
      case  4: Alert("  .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 135:Alert(" .   ..");
         RefreshRates();                        //  
         return(1);                             //   
      case 136:Alert(" .   ..");
         while(RefreshRates()==false)           //   
            Sleep(1);                           //   
         return(1);                             //   
      case 137:Alert(" .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 146:Alert("  .  ..");
         Sleep(500);                            //  
         return(1);                             //   
         //  
      case  2: Alert(" .");
         return(0);                             //   
      case  5: Alert("  .");
         Work=false;                            //   
         return(0);                             //   
      case 64: Alert(" .");
         Work=false;                            //   
         return(0);                             //   
      case 133:Alert(" .");
         return(0);                             //   
      case 134:Alert("    .");
         return(0);                             //   
      default: Alert("  ",Error); //     
         return(0);                             //   
     }
  } 

//----------------------------------------------------------------------------------9---
   //  
int New_Stop(int Parametr)                               //  
   {
    int Min_Dist= MarketInfo(Symbol(),MODE_STOPLEVEL);   // 
    if(Parametr < Min_Dist)                              //  ..
      {
       Parametr= Min_Dist;                               //.. . 
       Alert("   ");
      } 
    return(Parametr);                                    // 
   }           